Index: issm/trunk/src/android/helloworld/OpenGLES20/src/com/example/opengles20/Triangle.java
===================================================================
--- issm/trunk/src/android/helloworld/OpenGLES20/src/com/example/opengles20/Triangle.java	(revision 13975)
+++ issm/trunk/src/android/helloworld/OpenGLES20/src/com/example/opengles20/Triangle.java	(revision 13975)
@@ -0,0 +1,94 @@
+package com.example.opengles20;
+
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+import java.nio.FloatBuffer;
+
+import android.opengl.GLES20;
+
+class Triangle {
+
+    private FloatBuffer vertexBuffer;
+
+    // number of coordinates per vertex in this array
+    static final int COORDS_PER_VERTEX = 3;
+    static float triangleCoords[] = { // in counterclockwise order:
+         0.0f,  0.622008459f, 0.0f,   // top
+        -0.5f, -0.311004243f, 0.0f,   // bottom left
+         0.5f, -0.311004243f, 0.0f    // bottom right
+    };
+
+    private int mProgram; 
+    private int mPositionHandle;
+    private int mColorHandle;
+    private final int vertexCount = triangleCoords.length / COORDS_PER_VERTEX;
+    private final int vertexStride = COORDS_PER_VERTEX * 4; // bytes per vertex
+
+    // Set color with red, green, blue and alpha (opacity) values
+    float color[] = { 0.63671875f, 0.76953125f, 0.22265625f, 1.0f };
+    
+	private final String vertexShaderCode =
+			"attribute vec4 vPosition;" +
+			"void main() {" +
+			"  gl_Position = vPosition;" +
+			"}";
+
+	private final String fragmentShaderCode =
+			"precision mediump float;" +
+			"uniform vec4 vColor;" +
+			"void main() {" +
+			"  gl_FragColor = vColor;" +
+			"}";
+	
+
+    public Triangle() {
+        // initialize vertex byte buffer for shape coordinates
+        ByteBuffer bb = ByteBuffer.allocateDirect(
+                // (number of coordinate values * 4 bytes per float)
+                triangleCoords.length * 4);
+        // use the device hardware's native byte order
+        bb.order(ByteOrder.nativeOrder());
+
+        // create a floating point buffer from the ByteBuffer
+        vertexBuffer = bb.asFloatBuffer();
+        // add the coordinates to the FloatBuffer
+        vertexBuffer.put(triangleCoords);
+        // set the buffer to read the first coordinate
+        vertexBuffer.position(0);
+        int vertexShader = MyGL20Renderer.loadShader(GLES20.GL_VERTEX_SHADER, vertexShaderCode);
+        int fragmentShader = MyGL20Renderer.loadShader(GLES20.GL_FRAGMENT_SHADER, fragmentShaderCode);
+
+        mProgram = GLES20.glCreateProgram();             // create empty OpenGL ES Program
+        GLES20.glAttachShader(mProgram, vertexShader);   // add the vertex shader to program
+        GLES20.glAttachShader(mProgram, fragmentShader); // add the fragment shader to program
+        GLES20.glLinkProgram(mProgram);                  // creates OpenGL ES program executables
+    }
+    public void draw1() {
+        // Add program to OpenGL ES environment
+        GLES20.glUseProgram(mProgram);
+
+        // get handle to vertex shader's vPosition member
+        mPositionHandle = GLES20.glGetAttribLocation(mProgram, "vPosition");
+
+        // Enable a handle to the triangle vertices
+        GLES20.glEnableVertexAttribArray(mPositionHandle);
+
+        // Prepare the triangle coordinate data
+        GLES20.glVertexAttribPointer(mPositionHandle, COORDS_PER_VERTEX,
+                                     GLES20.GL_FLOAT, false,
+                                     vertexStride, vertexBuffer);
+
+        // get handle to fragment shader's vColor member
+        mColorHandle = GLES20.glGetUniformLocation(mProgram, "vColor");
+
+        // Set color for drawing the triangle
+        GLES20.glUniform4fv(mColorHandle, 1, color, 0);
+
+        // Draw the triangle
+        GLES20.glDrawArrays(GLES20.GL_TRIANGLES, 0, vertexCount);
+
+        // Disable vertex array
+        GLES20.glDisableVertexAttribArray(mPositionHandle);
+    }
+}
+
Index: issm/trunk/src/android/helloworld/Square/.classpath
===================================================================
--- issm/trunk/src/android/helloworld/Square/.classpath	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/.classpath	(revision 13975)
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="src" path="gen"/>
+	<classpathentry kind="con" path="com.android.ide.eclipse.adt.ANDROID_FRAMEWORK"/>
+	<classpathentry kind="con" path="com.android.ide.eclipse.adt.LIBRARIES"/>
+	<classpathentry kind="output" path="bin/classes"/>
+</classpath>
Index: issm/trunk/src/android/helloworld/Square/.project
===================================================================
--- issm/trunk/src/android/helloworld/Square/.project	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/.project	(revision 13975)
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>Square</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ResourceManagerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.PreCompilerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ApkBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>com.android.ide.eclipse.adt.AndroidNature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
Index: issm/trunk/src/android/helloworld/Square/.settings/org.eclipse.jdt.core.prefs
===================================================================
--- issm/trunk/src/android/helloworld/Square/.settings/org.eclipse.jdt.core.prefs	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/.settings/org.eclipse.jdt.core.prefs	(revision 13975)
@@ -0,0 +1,4 @@
+eclipse.preferences.version=1
+org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.5
+org.eclipse.jdt.core.compiler.compliance=1.5
+org.eclipse.jdt.core.compiler.source=1.5
Index: issm/trunk/src/android/helloworld/Square/bin/classes/com/example/square/SquareNumber.cpp
===================================================================
--- issm/trunk/src/android/helloworld/Square/bin/classes/com/example/square/SquareNumber.cpp	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/bin/classes/com/example/square/SquareNumber.cpp	(revision 13975)
@@ -0,0 +1,7 @@
+#include libSquareNumber;
+
+JNIEXPORT jint JNICALL Java_org_edwards_1research_demo_jni_SquaredWrapper_squared
+  (JNIEnv * je, jclass jc, jint base)
+{
+        return (base*base);
+}
Index: issm/trunk/src/android/helloworld/Square/jni/Android.mk
===================================================================
--- issm/trunk/src/android/helloworld/Square/jni/Android.mk	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/jni/Android.mk	(revision 13975)
@@ -0,0 +1,8 @@
+LOCAL_PATH := $(call my-dir)
+ 
+include $(CLEAR_VARS)
+ 
+LOCAL_MODULE    := squared
+LOCAL_SRC_FILES := SquaredNumber.cpp
+ 
+include $(BUILD_SHARED_LIBRARY)
Index: issm/trunk/src/android/helloworld/Square/src/com/example/square/Main.java
===================================================================
--- issm/trunk/src/android/helloworld/Square/src/com/example/square/Main.java	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/src/com/example/square/Main.java	(revision 13975)
@@ -0,0 +1,20 @@
+package com.example.square;
+
+import android.os.Bundle;
+import android.app.Activity;
+import android.view.Menu;
+
+public class Main extends Activity {
+
+    @Override
+    public void onCreate(Bundle savedInstanceState) {
+        super.onCreate(savedInstanceState);
+        setContentView(R.layout.activity_main);
+    }
+
+    @Override
+    public boolean onCreateOptionsMenu(Menu menu) {
+        getMenuInflater().inflate(R.menu.activity_main, menu);
+        return true;
+    }
+}
Index: issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.cpp
===================================================================
--- issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.cpp	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.cpp	(revision 13975)
@@ -0,0 +1,7 @@
+#include libSquareNumber;
+
+JNIEXPORT jint JNICALL Java_org_edwards_1research_demo_jni_SquaredWrapper_squared
+  (JNIEnv * je, jclass jc, jint base)
+{
+        return (base*base);
+}
Index: issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.java
===================================================================
--- issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.java	(revision 13975)
+++ issm/trunk/src/android/helloworld/Square/src/com/example/square/SquareNumber.java	(revision 13975)
@@ -0,0 +1,20 @@
+
+package com.example.square;
+
+
+public class SquareNumber {
+    // Declare native method (and make it public to expose it directly)
+    public static native int squared(int base);
+ 
+    // Provide additional functionality, that &quot;extends&quot; the native method
+    public static int to4(int base)
+    {
+        int sq = squared(base);
+        return squared(sq);
+    }
+ 
+    // Load library
+    static {
+        System.loadLibrary("libSquareNumber");
+    }
+}
Index: issm/trunk/src/android/helloworld/code/Main.cpp
===================================================================
--- issm/trunk/src/android/helloworld/code/Main.cpp	(revision 13975)
+++ issm/trunk/src/android/helloworld/code/Main.cpp	(revision 13975)
@@ -0,0 +1,14 @@
+
+#include "com_lan_factorial_FacLib.h"
+#include "fac.h"
+
+//extern long fac(long n);
+
+JNIEXPORT jlong JNICALL Java_com_lan_factorial_FacLib_fac(JNIEnv *env, jclass clazz, jlong n)
+{
+
+	fac *f = new fac();
+	jlong result = (jlong) (f->factorial(n));
+	delete(f);
+	return result ;
+}
Index: issm/trunk/src/android/helloworld/code/fac.cpp
===================================================================
--- issm/trunk/src/android/helloworld/code/fac.cpp	(revision 13975)
+++ issm/trunk/src/android/helloworld/code/fac.cpp	(revision 13975)
@@ -0,0 +1,14 @@
+#include "com_lan_factorial_FacLib.h"
+#include "fac.h"
+
+long fac::factorial(long n)
+{
+	long f = 1;
+	long i;
+	for(i = 1; i <= n; i++)
+	{
+		 f *= i;
+	}
+	return f;
+}
+
Index: issm/trunk/src/android/helloworld/code/fac.h
===================================================================
--- issm/trunk/src/android/helloworld/code/fac.h	(revision 13975)
+++ issm/trunk/src/android/helloworld/code/fac.h	(revision 13975)
@@ -0,0 +1,5 @@
+class fac
+{
+	public:
+	long factorial(long n);
+};
Index: issm/trunk/src/android/issm-android-inputfiles/test102.petsc
===================================================================
--- issm/trunk/src/android/issm-android-inputfiles/test102.petsc	(revision 13975)
+++ issm/trunk/src/android/issm-android-inputfiles/test102.petsc	(revision 13975)
@@ -0,0 +1,17 @@
+%Petsc options file: test102.petsc written from Matlab solver array
+
++NoneAnalysis
+-mat_type mpiaij
+-ksp_type preonly
+-pc_type lu
+-pc_factor_mat_solver_package mumps
+-mat_mumps_icntl_14 120
+-pc_factor_shift_positive_definite true
+
++DiagnosticVertAnalysis
+-mat_type mpiaij
+-ksp_type preonly
+-pc_type lu
+-pc_factor_mat_solver_package mumps
+-mat_mumps_icntl_14 120
+-pc_factor_shift_positive_definite true
Index: issm/trunk/src/android/issm-android-inputfiles/test102.sh
===================================================================
--- issm/trunk/src/android/issm-android-inputfiles/test102.sh	(revision 13975)
+++ issm/trunk/src/android/issm-android-inputfiles/test102.sh	(revision 13975)
@@ -0,0 +1,2 @@
+#!/bin/sh
+/Users/larour/issm-uci/trunk-jpl/bin/issm.exe DiagnosticSolution /Users/larour/issm-uci/trunk-jpl/src/android/test102 test102 
Index: issm/trunk/src/c/Container/Constraints.cpp
===================================================================
--- issm/trunk/src/c/Container/Constraints.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Constraints.cpp	(revision 13975)
@@ -49,10 +49,9 @@
 	/*figure out total number of constraints combining all the cpus (no clones here)*/
 	#ifdef _HAVE_MPI_
-		MPI_Reduce(&localconstraints,&numberofconstraints,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-		MPI_Bcast(&numberofconstraints,1,MPI_INT,0,MPI_COMM_WORLD);
+		MPI_Reduce(&localconstraints,&numberofconstraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+		MPI_Bcast(&numberofconstraints,1,MPI_INT,0,IssmComm::GetComm());
 	#else
 		numberofconstraints=localconstraints;
 	#endif
-	
 
 	return numberofconstraints;
Index: issm/trunk/src/c/Container/Constraints.h
===================================================================
--- issm/trunk/src/c/Container/Constraints.h	(revision 13405)
+++ issm/trunk/src/c/Container/Constraints.h	(revision 13975)
@@ -16,20 +16,16 @@
 class Inputs;
 
-
 class Constraints: public DataSet{
 
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Constraints();
 		~Constraints();
-		/*}}}*/
-		/*numerics: {{{*/
+
+		/*numerics*/
 		int   NumberOfConstraints(void);
-		/*}}}*/
 
 };
 
-
 #endif //ifndef _CONSTRAINTS_H_
-
Index: issm/trunk/src/c/Container/DataSet.cpp
===================================================================
--- issm/trunk/src/c/Container/DataSet.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/DataSet.cpp	(revision 13975)
@@ -30,5 +30,5 @@
 /*FUNCTION DataSet::DataSet(){{{*/
 DataSet::DataSet(){
-	
+
 	sorted=0;
 	sorted_ids=NULL;
@@ -40,5 +40,5 @@
 DataSet::DataSet(int dataset_enum){
 	enum_type=dataset_enum;
-	
+
 	sorted=0;
 	sorted_ids=NULL;
@@ -50,9 +50,8 @@
 DataSet*   DataSet::Copy(void){
 
-	DataSet* copy=NULL;
 	vector<Object*>::iterator object;
 	Object* object_copy=NULL;
 
-	copy=new DataSet(enum_type);
+	DataSet* copy=new DataSet(enum_type);
 
 	copy->sorted=sorted;
@@ -130,5 +129,4 @@
 void DataSet::DeepEcho(){
 
-
 	vector<Object*>::iterator object;
 
@@ -191,5 +189,4 @@
 	int id_offset;
 	int offset;
-	int i;
 
 	_assert_(this);
@@ -216,6 +213,4 @@
 	/*vector of objects is already sorted, just allocate the sorted ids and their
 	 * offsets:*/
-	int i;
-
 	if(objects.size()){
 
@@ -229,5 +224,5 @@
 
 		/*Build id_offsets and sorted_ids*/
-		for(i=0;i<objects.size();i++){
+		for(int i=0;i<objects.size();i++){
 			id_offsets[i]=i;
 			sorted_ids[i]=objects[i]->Id();
Index: issm/trunk/src/c/Container/DataSet.h
===================================================================
--- issm/trunk/src/c/Container/DataSet.h	(revision 13405)
+++ issm/trunk/src/c/Container/DataSet.h	(revision 13975)
@@ -23,13 +23,13 @@
 
 class DataSet{
-	
+
 	public: 
-		
+
 		/*internals: */
 		std::vector<Object*> objects;
-		
+
 		/*type of dataset: */
 		int             enum_type;
-		
+
 		/*sorting: */
 		int             sorted;
@@ -38,27 +38,26 @@
 		int*            id_offsets;
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		DataSet();
 		DataSet(int enum_type);
 		~DataSet();
-		/*}}}*/
-		/*management: {{{*/
-		int   GetEnum();
-		int   GetEnum(int offset);
-		void  Echo();
-		void  DeepEcho();
-		int   AddObject(Object* object);
-		int   DeleteObject(int id);
-		int   Size();
-		void  clear();
-		Object* GetObjectByOffset(int offset);
-		Object* GetObjectById(int* poffset,int eid);
-		void  Presort();
-		void  SetSorting(int* in_sorted_ids,int* in_id_offsets);
-		void  Sort();
-		DataSet* Copy(void);
-		int   DeleteObject(Object* object);
-		Results* SpawnTriaResults(int* indices);
-		/*}}}*/
+
+		/*management*/
+		int      GetEnum();
+		int      GetEnum(int offset);
+		void     Echo();
+		void     DeepEcho();
+		int      AddObject(Object *object);
+		int      DeleteObject(int id);
+		int      Size();
+		void     clear();
+		Object  *GetObjectByOffset(int  offset);
+		Object  *GetObjectById(int *poffset,int eid);
+		void     Presort();
+		void     SetSorting(int *in_sorted_ids,int*in_id_offsets);
+		void     Sort();
+		DataSet *Copy(void);
+		int      DeleteObject(Object *object);
+		Results *SpawnTriaResults(int *indices);
 
 };
Index: issm/trunk/src/c/Container/Elements.cpp
===================================================================
--- issm/trunk/src/c/Container/Elements.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Elements.cpp	(revision 13975)
@@ -46,5 +46,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		element=(Element*)(*object);
+		element=dynamic_cast<Element*>((*object));
 		element->Configure(elements,loads,nodes,materials,parameters);
 
@@ -58,5 +58,5 @@
 	//Process results to be output in the correct units
 	for(int i=0;i<this->Size();i++){
-		Element* element=(Element*)this->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
 		element->ProcessResultsUnits();
 	}
@@ -65,7 +65,7 @@
 /*FUNCTION Elements::DeleteResults{{{*/
 void Elements::DeleteResults(void){
-	
+
 	for (int i=0;i<this->Size();i++){
-		Element* element=(Element*)this->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
 		element->DeleteResults();
 	}
@@ -108,5 +108,5 @@
 	 * We will use the Patch object, which will store all of the information needed, and will be able 
 	 * to output itself to disk on its own. See object/Patch.h for format of this object.*/
-	
+
 	/*First, determine maximum number of vertices, nodes, and number of results: */
 	numrows=0;
@@ -116,5 +116,5 @@
 	for(i=0;i<this->Size();i++){
 
-		Element* element=(Element*)this->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
 		element->PatchSize(&element_numrows,&element_numvertices,&element_numnodes);
 
@@ -126,10 +126,10 @@
 	/*Synchronize across cluster, so as to not end up with different sizes for each patch on each cpu: */
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&numvertices,&max_numvertices,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD );
-	MPI_Bcast(&max_numvertices,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Reduce (&numvertices,&max_numvertices,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&max_numvertices,1,MPI_INT,0,IssmComm::GetComm());
 	numvertices=max_numvertices;
 
-	MPI_Reduce (&numnodes,&max_numnodes,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD );
-	MPI_Bcast(&max_numnodes,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Reduce (&numnodes,&max_numnodes,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&max_numnodes,1,MPI_INT,0,IssmComm::GetComm());
 	numnodes=max_numnodes;
 	#endif
@@ -141,5 +141,5 @@
 	count=0;
 	for(i=0;i<this->Size();i++){
-		Element* element=(Element*)this->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
 		element->PatchFill(&count,patch);
 	}
@@ -156,5 +156,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		element=(Element*)(*object);
+		element=dynamic_cast<Element*>((*object));
 		element->SetCurrentConfiguration(elements,loads,nodes,materials,parameters);
 
@@ -166,22 +166,24 @@
 void Elements::ToResults(Results* results,Parameters* parameters){
 
-	int i;
-	
-	extern int my_rank;
-	extern int num_procs;
-
-	Patch  *patch        = NULL;
-	int    *resultsenums = NULL;
-	int    *resultssizes  = NULL;
-	int    *resultssteps  = NULL;
-	IssmDouble *resultstimes = NULL;
-	IssmDouble *vector_serial= NULL;
-	Vector<IssmDouble>*     vector       = NULL;
-	bool   io_gather;
-	bool   results_as_patches;
-	int    numberofvertices,numberofelements;
-	int    numberofresults,vectorsize;
-	int    rank;
-	int    minrank;
+	int my_rank;
+	int num_procs;
+
+	Patch               *patch              = NULL;
+	int                 *resultsenums       = NULL;
+	int                 *resultssizes       = NULL;
+	int                 *resultssteps       = NULL;
+	IssmDouble          *resultstimes       = NULL;
+	IssmDouble          *vector_serial      = NULL;
+	Vector<IssmDouble> *vector = NULL;
+	bool                io_gather;
+	bool                results_as_patches;
+	int                 numberofvertices     ,numberofelements;
+	int                 numberofresults      ,vectorsize;
+	int                 rank;
+	int                 minrank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+	num_procs=IssmComm::GetSize();
 
 	/*Recover parameters: */
@@ -198,5 +200,5 @@
 		if(this->Size()) rank=my_rank;
 		else rank=num_procs;
-		MPI_Allreduce (&rank,&minrank,1,MPI_INT,MPI_MIN,MPI_COMM_WORLD);
+		MPI_Allreduce (&rank,&minrank,1,MPI_INT,MPI_MIN,IssmComm::GetComm());
 		#else
 		minrank=my_rank;
@@ -206,9 +208,9 @@
 		if(my_rank==minrank){
 			if(this->Size()==0) _error_("Cannot write results because there is no element??");
-			Element* element=(Element*)this->GetObjectByOffset(0);
+			Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(0));
 			element->ListResultsInfo(&resultsenums,&resultssizes,&resultstimes,&resultssteps,&numberofresults);
 		}
 		#ifdef _HAVE_MPI_
-		MPI_Bcast(&numberofresults,1,MPI_DOUBLE,minrank,MPI_COMM_WORLD);
+		MPI_Bcast(&numberofresults,1,MPI_DOUBLE,minrank,IssmComm::GetComm());
 		#endif
 
@@ -222,8 +224,8 @@
 			resultssteps=xNew<int>(numberofresults);
 		}
-		MPI_Bcast(resultsenums,numberofresults,MPI_INT,minrank,MPI_COMM_WORLD);
-		MPI_Bcast(resultssizes,numberofresults,MPI_INT,minrank,MPI_COMM_WORLD);
-		MPI_Bcast(resultstimes,numberofresults,MPI_DOUBLE,minrank,MPI_COMM_WORLD);
-		MPI_Bcast(resultssteps,numberofresults,MPI_INT,minrank,MPI_COMM_WORLD);
+		MPI_Bcast(resultsenums,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultssizes,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultstimes,numberofresults,MPI_DOUBLE,minrank,IssmComm::GetComm());
+		MPI_Bcast(resultssteps,numberofresults,MPI_INT,minrank,IssmComm::GetComm());
 		#endif
 
@@ -238,5 +240,5 @@
 
 			for(int j=0;j<this->Size();j++){
-				Element* element=(Element*)this->GetObjectByOffset(j);
+				Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(j));
 				element->GetVectorFromResults(vector,i,resultsenums[i],resultssizes[i]);
 			}
@@ -292,13 +294,37 @@
 }
 /*}}}*/
+/*FUNCTION Elements::MaxNumNodes{{{*/
+int Elements::MaxNumNodes(void){
+
+	int max=0;
+	int allmax;
+	int numnodes=0;
+
+	/*Now go through all elements, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
+		numnodes=element->GetNumberOfNodes();
+		if(numnodes>max)max=numnodes;
+	}
+
+	/*Grab max of all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	max=allmax;
+	#endif
+
+	return max;
+}
+/*}}}*/
 /*FUNCTION Elements::NumberOfElements{{{*/
 int Elements::NumberOfElements(void){
 
-	int local_nelem=0;
+	int local_nelem;
 	int numberofelements;
 
 	local_nelem=this->Size();
 	#ifdef _HAVE_MPI_
-	MPI_Allreduce ( (void*)&local_nelem,(void*)&numberofelements,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
+	MPI_Allreduce ( (void*)&local_nelem,(void*)&numberofelements,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
 	#else
 	numberofelements=local_nelem;
@@ -312,5 +338,5 @@
 
 	for(int i=0;i<this->Size();i++){
-		Element* element=(Element*)this->GetObjectByOffset(i);
+		Element* element=dynamic_cast<Element*>(this->GetObjectByOffset(i));
 		element->InputDuplicate(input_enum,output_enum);
 	}
Index: issm/trunk/src/c/Container/Elements.h
===================================================================
--- issm/trunk/src/c/Container/Elements.h	(revision 13405)
+++ issm/trunk/src/c/Container/Elements.h	(revision 13975)
@@ -20,18 +20,18 @@
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Elements();
 		~Elements();
-		/*}}}*/
-		/*numerics: {{{*/
-		void Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
-		void DeleteResults(void);
-		void ProcessResultsUnits(void);
-		void SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
-		void ToResults(Results* results,Parameters* parameters);
+
+		/*numerics*/
+		void   Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void   DeleteResults(void);
+		int    MaxNumNodes(void);
+		void   ProcessResultsUnits(void);
+		void   SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void   ToResults(Results* results,Parameters* parameters);
 		Patch* ResultsToPatch(void);
-		int   NumberOfElements(void);
-		void InputDuplicate(int input_enum,int output_enum);
-		/*}}}*/
+		int    NumberOfElements(void);
+		void   InputDuplicate(int input_enum,int output_enum);
 
 };
Index: issm/trunk/src/c/Container/Inputs.cpp
===================================================================
--- issm/trunk/src/c/Container/Inputs.cpp	(revision 13405)
+++ issm/trunk/src/c/Container/Inputs.cpp	(revision 13975)
@@ -47,5 +47,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -75,5 +75,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -103,5 +103,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object); 
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -131,5 +131,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 		if (input->InstanceEnum()==enum_type){
 			found=true;
@@ -163,5 +163,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 
 		if (input->InstanceEnum()==in_input->InstanceEnum()){
@@ -185,5 +185,5 @@
 	/*Delete existing input of newenumtype if it exists*/
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 
 		if (input->InstanceEnum()==newenumtype){
@@ -196,5 +196,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 
 		if (input->InstanceEnum()==oldenumtype){
@@ -207,8 +207,7 @@
 /*FUNCTION Inputs::ConstrainMin{{{*/
 void  Inputs::ConstrainMin(int constrain_enum, IssmDouble minimum){
-	   
-	Input* constrain_input=NULL; 
+
 	/*Find x and y inputs: */
-	constrain_input=(Input*)this->GetInput(constrain_enum);
+	Input* constrain_input=dynamic_cast<Input*>(this->GetInput(constrain_enum));
 
 	/*some checks: */
@@ -226,5 +225,5 @@
 
 	/*Get input*/
-	Input* input=(Input*)this->GetInput(enumtype);
+	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -247,5 +246,5 @@
 
 	/*Get input*/
-	Input* input=(Input*)this->GetInput(enumtype);
+	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -268,5 +267,5 @@
 
 	/*Get input*/
-	Input* input=(Input*)this->GetInput(enumtype);
+	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -289,5 +288,5 @@
 
 	/*Get input*/
-	Input* input=(Input*)this->GetInput(enumtype);
+	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -310,5 +309,5 @@
 
 	/*Get input*/
-	Input* input=(Input*)this->GetInput(enumtype);
+	Input* input=dynamic_cast<Input*>(this->GetInput(enumtype));
 
 	/*Apply ContrainMin: */
@@ -332,5 +331,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 
 		if (input->InstanceEnum()==enum_name){
@@ -349,5 +348,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object); 
+		input=dynamic_cast<Input*>(*object);
 
 		if (input->InstanceEnum()==enum_type){
@@ -364,11 +363,8 @@
 void  Inputs::DuplicateInput(int original_enum,int new_enum){
 
-	Input* original=NULL;
-	Input* copy=NULL;
-
 	/*Make a copy of the original input: */
-	original=(Input*)this->GetInput(original_enum);
+	Input* original=dynamic_cast<Input*>(this->GetInput(original_enum));
 	if(!original)_error_("could not find input with enum: " << EnumToStringx(original_enum)); 
-	copy=(Input*)original->copy();
+	Input* copy=dynamic_cast<Input*>(original->copy());
 
 	/*Change copy enum to reinitialized_enum: */
@@ -376,5 +372,5 @@
 
 	/*Add copy into inputs, it will wipe off the one already there: */
-	this->AddInput((Input*)copy);
+	this->AddInput(dynamic_cast<Input*>(copy));
 }
 /*}}}*/
@@ -394,5 +390,5 @@
 
 		/*Create new input*/
-		inputin=(Input*)(*object); 
+		inputin=dynamic_cast<Input*>(*object);
 		inputout=inputin->SpawnTriaInput(indices);
 
@@ -407,11 +403,8 @@
 /*FUNCTION Inputs::AXPY{{{*/
 void  Inputs::AXPY(int MeshYEnum, IssmDouble scalar, int MeshXEnum){
-	   
-	Input* xinput=NULL;
-	Input* yinput=NULL;
 
 	/*Find x and y inputs: */
-	xinput=(Input*)this->GetInput(MeshXEnum);
-	yinput=(Input*)this->GetInput(MeshYEnum);
+	Input* xinput=dynamic_cast<Input*>(this->GetInput(MeshXEnum));
+	Input* yinput=dynamic_cast<Input*>(this->GetInput(MeshYEnum));
 
 	/*some checks: */
@@ -431,5 +424,5 @@
 	for ( object=objects.begin() ; object < objects.end(); object++ ){
 
-		input=(Input*)(*object);
+		input=dynamic_cast<Input*>(*object);
 		input->Configure(parameters);
 
Index: issm/trunk/src/c/Container/Inputs.h
===================================================================
--- issm/trunk/src/c/Container/Inputs.h	(revision 13405)
+++ issm/trunk/src/c/Container/Inputs.h	(revision 13975)
@@ -23,18 +23,17 @@
 	public:
 
-		/*constructors, destructors: {{{*/
+		/*constructors, destructors*/
 		Inputs();
 		~Inputs();
 
-		/*}}}*/
-		/*numerics: {{{*/
-		int     AddInput(Input* in_input);
-		void    ChangeEnum(int enumtype,int new_enumtype);
-		void    ConstrainMin(int constrain_enum, IssmDouble minimum);
-		int     DeleteInput(int enum_type);
-		void    DuplicateInput(int original_enum,int new_enum);
-		Input*  GetInput(int enum_name);
-		Inputs* SpawnTriaInputs(int* indices);
-		void    AXPY(int MeshYEnum, IssmDouble scalar, int MeshXEnum);
+		/*numerics*/
+		int        AddInput(Input* in_input);
+		void       ChangeEnum(int enumtype,int new_enumtype);
+		void       ConstrainMin(int constrain_enum, IssmDouble minimum);
+		int        DeleteInput(int enum_type);
+		void       DuplicateInput(int original_enum,int new_enum);
+		Input*     GetInput(int enum_name);
+		Inputs*    SpawnTriaInputs(int* indices);
+		void       AXPY(int MeshYEnum, IssmDouble scalar, int MeshXEnum);
 		IssmDouble  InfinityNorm(int enumtype);
 		IssmDouble  Max(int enumtype);
@@ -42,12 +41,9 @@
 		IssmDouble  Min(int enumtype);
 		IssmDouble  MinAbs(int enumtype);
-		
 		void GetInputAverage(IssmDouble* pvalue, int enum_type);
 		void GetInputValue(bool* pvalue,int enum_type);
 		void GetInputValue(int* pvalue,int enum_type);
 		void GetInputValue(IssmDouble* pvalue,int enum_type);
-
 		void Configure(Parameters* parameters);
-		/*}}}*/
 
 };
